#version 130 // GLSL verzia

uniform sampler2D base_tex_unit; // zakladna textura
uniform sampler2D nm_tex_unit;   // normalmap textura

// vstup z vertex shadera
in vec3 T;  // tangenta
in vec3 B;  // bitangenta
in vec3 N;  // normala
in vec2 uv; // texturovacie suradnice
in vec4 ambient;

vec3 normal; // pomocna premenna pre ulozenie normaly

// ulozenie float do 4-prvkoveho byte vektora
vec4 packFtoVEC(const float F)
{
 const vec4 bitSh=vec4((255.0*255.0*255.0),(255.0*255.0),255.0,1.0);
 const vec4 bitMsk=vec4(0.0,1.0/255.0,1.0/255.0,1.0/255.0);
 vec4 res=fract(F*bitSh);
 res-=res.xxyz*bitMsk;
 return(res);
}

void main()
{
 // transformacia normaly nacitanej z normalmapy
 // (definovana v Tangent space) do EYE space
 // v texture je normala v intervale <0;1>
 // prevod z <0;1> do <-1;1> je realizovany pomocou *2.0-1.0
 // prevod z <-1;1> do <0;1> je realizovany pomocou *0.5+0.5
 normal=texture(nm_tex_unit,uv).xyz*2.0-1.0;
 normal=normalize(normal.x*T+normal.y*B+normal.z*N)*0.5+0.5;

 // naplnenie FBO pre nespracovane udaje
 // albedo
 gl_FragData[0]=texture(base_tex_unit,uv)*ambient;
 // normal
 gl_FragData[1]=vec4(normal,0.0);
 // depth
 gl_FragData[2]=packFtoVEC(gl_FragCoord.z);
}
